#ifndef ROLAND_COMPILERSPEC_H
#define ROLAND_COMPILERSPEC_H

namespace roland
{
    const char* const ROLAND_SYSTEM             = "Linux-4.4.57-18.3-default";
    const char* const ROLAND_SYSTEM_NAME        = "Linux";

    const char* const ROLAND_COMPILER_ID        = "GNU";
    const char* const ROLAND_COMPILER_VERSION   = "4.8.5";
    const char* const ROLAND_COMPILER_CXX_FLAGS = " -std=c++11";
    
    const char* const ROLAND_SIZEOF_VOIDP       = "8";
}


#define HAS_CONSTEXPR_SPECIFIER
#define HAS_FINAL_SPECIFIER
#define HAS_NOEXCEPT_SPECIFIER
/* #undef HAS_MAKE_UNIQUE */
#define HAS_DEFAULT_TEMPLATE_ARGS_FOR_FUNCTIONS
#define HAS_THREAD_LOCAL_STORAGE
#define HAS_DEFAULT_AND_DELETE
#define HAS_VARIADIC_TEMPLATES
#define HAS_NON_BUGGY_TYPE_TRAITS
/* #undef HAS_ROBUST_NONMODIFYING_SEQ_OPS */
#define HAS_INITIALIZER_LISTS
/* #undef HAS_EXPLICIT_SPECIFIER */



#ifdef ROLAND_NOEXCEPT
    #error "*** ROLAND_NOEXCEPT is already defined and may not match requested behaviour. ***"
#else
    #ifdef HAS_NOEXCEPT_SPECIFIER   
        #define ROLAND_NOEXCEPT noexcept
    #else
        #define ROLAND_NOEXCEPT
    #endif
#endif  

    #if defined(ROLAND_DEFAULT) || defined(ROLAND_DELETE)
    #error "*** ROLAND_DEFAULT & ROLAND_DELETE are already defined and may not match requested behaviour. ***"
#else
    #ifdef HAS_DEFAULT_AND_DELETE
        #define ROLAND_DEFAULT = default;
        #define ROLAND_DELETE = delete;
    #else
        #define ROLAND_DEFAULT {}
        #define ROLAND_DELETE {}
    #endif
#endif  


#ifdef ROLAND_EXPLICIT
    #error "*** ROLAND_EXPLICIT is already defined and may not match requested behaviour. ***"
#else   
    #ifdef HAS_EXPLICIT_SPECIFIER
        #define ROLAND_EXPLICIT explicit
    #else
        #define ROLAND_EXPLICIT
    #endif
#endif

#ifdef ROLAND_FINAL
    #error "*** ROLAND_FINAL is already defined and may not match requested behaviour. ***"
#else   
    #ifdef HAS_FINAL_SPECIFIER
        #define ROLAND_FINAL final
    #else
        #define ROLAND_FINAL
    #endif
#endif

#ifdef ROLAND_CONSTEXPR
    #error "*** ROLAND_CONSTEXPR is already defined and may not match requested behaviour. ***"
#else   
    #ifdef HAS_CONSTEXPR_SPECIFIER
        #define ROLAND_CONSTEXPR constexpr
    #else
        #define ROLAND_CONSTEXPR const
    #endif
#endif

#endif // ROLAND_COMPILERSPEC_H
