/***************************************************************************
 *   Copyright (C) by Fred Klaus                                           *
 *       development@fkweb.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CPC_CPCKEYS_H
#define CPC_CPCKEYS_H

#include "types.h"

namespace cpcx
{

    static const tUBYTE cpckey[256][4] =
    {
        { 0x00, 0x00, 0x00, 0x00 }, //   ? - Row - Key - ?
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x01, 0x09, 0x80, 0x00 }, /* bs  */
        { 0x01, 0x08, 0x10, 0x00 }, /* ht  */
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x01, 0x02, 0x04, 0x00 }, /* cr  */
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x01, 0x08, 0x04, 0x00 }, /* esc */
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x01, 0x05, 0x80, 0x00 }, /* sp  */
        { 0x01, 0x08, 0x01, 0x01 }, /* !   */
        { 0x01, 0x08, 0x02, 0x01 }, /* "   */
        { 0x01, 0x07, 0x02, 0x01 }, /* #   */
        { 0x01, 0x07, 0x01, 0x01 }, /* $   */
        { 0x01, 0x06, 0x02, 0x01 }, /* %   */
        { 0x01, 0x06, 0x01, 0x01 }, /* &   */
        { 0x01, 0x05, 0x02, 0x01 }, /* '   */
        { 0x01, 0x05, 0x01, 0x01 }, /* (   */
        { 0x01, 0x04, 0x02, 0x01 }, /* )   */
        { 0x01, 0x03, 0x20, 0x01 }, /* *   */
        { 0x01, 0x03, 0x10, 0x01 }, /* +   */
        { 0x01, 0x04, 0x80, 0x00 }, /* ,   */
        { 0x01, 0x03, 0x02, 0x00 }, /* -   */
        { 0x01, 0x03, 0x80, 0x00 }, /* .   */
        { 0x01, 0x03, 0x40, 0x00 }, /* /   */
        { 0x01, 0x04, 0x01, 0x00 }, /* 0   */
        { 0x01, 0x08, 0x01, 0x00 }, /* 1   */
        { 0x01, 0x08, 0x02, 0x00 }, /* 2   */
        { 0x01, 0x07, 0x02, 0x00 }, /* 3   */
        { 0x01, 0x07, 0x01, 0x00 }, /* 4   */
        { 0x01, 0x06, 0x02, 0x00 }, /* 5   */
        { 0x01, 0x06, 0x01, 0x00 }, /* 6   */
        { 0x01, 0x05, 0x02, 0x00 }, /* 7   */
        { 0x01, 0x05, 0x01, 0x00 }, /* 8   */
        { 0x01, 0x04, 0x02, 0x00 }, /* 9   */
        { 0x01, 0x03, 0x20, 0x00 }, /* :   */
        { 0x01, 0x03, 0x10, 0x00 }, /* ;   */
        { 0x01, 0x04, 0x80, 0x00 }, /* <   */
        { 0x01, 0x03, 0x02, 0x01 }, /* =   */
        { 0x01, 0x03, 0x80, 0x00 }, /* >   */
        { 0x01, 0x03, 0x40, 0x01 }, /* ?   */
        { 0x01, 0x03, 0x04, 0x00 }, /* @   */
        { 0x01, 0x08, 0x20, 0x01 }, /* A   */
        { 0x01, 0x06, 0x40, 0x01 }, /* B   */
        { 0x01, 0x07, 0x40, 0x01 }, /* C   */
        { 0x01, 0x07, 0x20, 0x01 }, /* D   */
        { 0x01, 0x07, 0x04, 0x01 }, /* E   */
        { 0x01, 0x06, 0x20, 0x01 }, /* F   */
        { 0x01, 0x06, 0x10, 0x01 }, /* G   */
        { 0x01, 0x05, 0x10, 0x01 }, /* H   */
        { 0x01, 0x04, 0x08, 0x01 }, /* I   */
        { 0x01, 0x05, 0x20, 0x01 }, /* J   */
        { 0x01, 0x04, 0x20, 0x01 }, /* K   */
        { 0x01, 0x04, 0x10, 0x01 }, /* L   */
        { 0x01, 0x04, 0x40, 0x01 }, /* M   */
        { 0x01, 0x05, 0x40, 0x01 }, /* N   */
        { 0x01, 0x04, 0x04, 0x01 }, /* O   */
        { 0x01, 0x03, 0x08, 0x01 }, /* P   */
        { 0x01, 0x08, 0x08, 0x01 }, /* Q   */
        { 0x01, 0x06, 0x04, 0x01 }, /* R   */
        { 0x01, 0x07, 0x10, 0x01 }, /* S   */
        { 0x01, 0x06, 0x08, 0x01 }, /* T   */
        { 0x01, 0x05, 0x04, 0x01 }, /* U   */
        { 0x01, 0x06, 0x80, 0x01 }, /* V   */
        { 0x01, 0x07, 0x08, 0x01 }, /* W   */
        { 0x01, 0x07, 0x80, 0x01 }, /* X   */
        { 0x01, 0x05, 0x08, 0x01 }, /* Y   */
        { 0x01, 0x08, 0x80, 0x01 }, /* Z   */
        { 0x01, 0x02, 0x02, 0x00 }, /* [   */
        { 0x01, 0x02, 0x40, 0x00 }, /* \   */
        { 0x01, 0x02, 0x08, 0x00 }, /* ]   */
        { 0x01, 0x03, 0x01, 0x00 }, /* ^   */
        { 0x01, 0x04, 0x01, 0x01 }, /* _   */
        { 0x01, 0x02, 0x40, 0x01 }, /* `   */
        { 0x01, 0x08, 0x20, 0x00 }, /* a   */
        { 0x01, 0x06, 0x40, 0x00 }, /* b   */
        { 0x01, 0x07, 0x40, 0x00 }, /* c   */
        { 0x01, 0x07, 0x20, 0x00 }, /* d   */
        { 0x01, 0x07, 0x04, 0x00 }, /* e   */
        { 0x01, 0x06, 0x20, 0x00 }, /* f   */
        { 0x01, 0x06, 0x10, 0x00 }, /* g   */
        { 0x01, 0x05, 0x10, 0x00 }, /* h   */
        { 0x01, 0x04, 0x08, 0x00 }, /* i   */
        { 0x01, 0x05, 0x20, 0x00 }, /* j   */
        { 0x01, 0x04, 0x20, 0x00 }, /* k   */
        { 0x01, 0x04, 0x10, 0x00 }, /* l   */
        { 0x01, 0x04, 0x40, 0x00 }, /* m   */
        { 0x01, 0x05, 0x40, 0x00 }, /* n   */
        { 0x01, 0x04, 0x04, 0x00 }, /* o   */
        { 0x01, 0x03, 0x08, 0x00 }, /* p   */
        { 0x01, 0x08, 0x08, 0x00 }, /* q   */
        { 0x01, 0x06, 0x04, 0x00 }, /* r   */
        { 0x01, 0x07, 0x10, 0x00 }, /* s   */
        { 0x01, 0x06, 0x08, 0x00 }, /* t   */
        { 0x01, 0x05, 0x04, 0x00 }, /* u   */
        { 0x01, 0x06, 0x80, 0x00 }, /* v   */
        { 0x01, 0x07, 0x08, 0x00 }, /* w   */
        { 0x01, 0x07, 0x80, 0x00 }, /* x   */
        { 0x01, 0x05, 0x08, 0x00 }, /* y   */
        { 0x01, 0x08, 0x80, 0x00 }, /* z   */
        { 0x01, 0x02, 0x02, 0x01 }, /* {   */
        { 0x01, 0x03, 0x04, 0x01 }, /* |   */
        { 0x01, 0x02, 0x08, 0x01 }, /* }   */
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x01, 0x02, 0x01, 0x00 }, /* del */
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00 },
    };

} // cpc

#endif // CPC_CPCKEYS_H
